<?php
require "config.php";

// 添加 CodeMirror 资源函数（更新版，包含补全功能）
function includeCodeMirror($mode = 'text/plain') {
    echo <<<HTML
    <!-- 引入 CodeMirror 基础资源 -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/codemirror.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/codemirror.min.js"></script>
    
    <!-- 引入语言模式 -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/htmlmixed/htmlmixed.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/xml/xml.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/javascript/javascript.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/css/css.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/clike/clike.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/php/php.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/shell/shell.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/python/python.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/markdown/markdown.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/mode/sql/sql.min.js"></script>
    
    <!-- 引入代码补全插件 -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/show-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/javascript-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/xml-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/html-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/css-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/anyword-hint.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/sql-hint.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.65.2/addon/hint/show-hint.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.56.0/theme/material-darker.min.css"/>
    
    <style>
        .CodeMirror {
            border: 1px solid #444;
            height: auto;
            font-size: 14px;
            line-height: 1.5;
            margin-bottom: 10px;
            background: #212121;
        }
        .CodeMirror-scroll {
            min-height: 400px;
        }
        .cm-s-material-darker .CodeMirror-gutters {
            background: #212121 !important;
            border-right: 1px solid #333;
        }
        #codeViewer {
            display: none;
        }
        /* 补全提示框样式 */
        .CodeMirror-hints {
            background: #333;
            border: 1px solid #444;
            color: #eee;
            z-index: 1000;
        }
        .CodeMirror-hint {
            color: #eee;
            padding: 5px 10px;
        }
        li.CodeMirror-hint-active {
            background: #444;
            color: #fff;
        }
    </style>
    
    <script>
    // 定义各种语言的补全关键字
    var languageKeywords = {
        'clike': ['auto', 'break', 'case', 'char', 'const', 'continue', 'default', 'do', 'double', 
                 'else', 'enum', 'extern', 'float', 'for', 'goto', 'if', 'int', 'long', 'register', 
                 'return', 'short', 'signed', 'sizeof', 'static', 'struct', 'switch', 'typedef', 
                 'union', 'unsigned', 'void', 'volatile', 'while', 'printf', 'scanf', 'include',
                 'define', 'ifdef', 'ifndef', 'endif', 'class', 'public', 'private', 'protected',
                 'new', 'delete', 'this', 'virtual', 'extends', 'implements', 'import', 'package',
                 'try', 'catch', 'finally', 'throw', 'throws'],
        
        'python': ['and', 'as', 'assert', 'break', 'class', 'continue', 'def', 'del', 'elif', 'else',
                  'except', 'False', 'finally', 'for', 'from', 'global', 'if', 'import', 'in', 'is',
                  'lambda', 'None', 'nonlocal', 'not', 'or', 'pass', 'raise', 'return', 'True', 'try',
                  'while', 'with', 'yield', 'print', 'input', 'len', 'range', 'str', 'int', 'float',
                  'list', 'dict', 'tuple', 'set', 'open', 'with', 'self'],
        
        'php': ['<?php', '?>', 'echo', 'print', 'if', 'else', 'elseif', 'while', 'do', 'for', 
               'foreach', 'switch', 'case', 'break', 'continue', 'function', 'return', 'class', 
               'public', 'private', 'protected', 'static', 'const', 'abstract', 'interface', 
               'extends', 'implements', 'new', 'try', 'catch', 'finally', 'throw', 'namespace', 
               'use', 'require', 'require_once', 'include', 'include_once', 'array', 'isset', 
               'empty', 'unset', 'list', 'die', 'exit', 'var_dump', 'print_r']
    };
    
    // 自定义补全函数
    function customHint(cm) {
        var cur = cm.getCursor(), token = cm.getTokenAt(cur);
        var mode = cm.getMode().name;
        var start = token.start, end = token.end;
        
        // 获取当前语言的关键字
        var keywords = [];
        if (mode === 'clike' || mode === 'text/x-csrc' || mode === 'text/x-c++src' || mode === 'text/x-java') {
            keywords = languageKeywords['clike'];
        } else if (mode === 'python') {
            keywords = languageKeywords['python'];
        } else if (mode === 'application/x-httpd-php' || mode === 'php') {
            keywords = languageKeywords['php'];
        }
        
        // 获取当前文档中的所有单词
        var wordList = [];
        cm.eachLine(function(line) {
            var words = line.text.match(/[a-zA-Z_][a-zA-Z0-9_]*/g);
            if (words) {
                wordList = wordList.concat(words);
            }
        });
        
        // 合并关键字和文档中的单词，去重
        var list = keywords.concat(wordList.filter(function(word) {
            return keywords.indexOf(word) === -1;
        }));
        
        // 过滤出以当前输入开头的单词
        var curWord = token.string;
        var filtered = list.filter(function(item) {
            return item.toLowerCase().indexOf(curWord.toLowerCase()) === 0;
        });
        
        // 去重并排序
        filtered = [...new Set(filtered)].sort();
        
        return {
            list: filtered,
            from: CodeMirror.Pos(cur.line, start),
            to: CodeMirror.Pos(cur.line, end)
        };
    }
    
    document.addEventListener('DOMContentLoaded', function() {
        var editor = CodeMirror.fromTextArea(document.getElementById('codeEditor'), {
            lineNumbers: true,
            mode: '$mode',
            theme: 'material-darker',
            indentUnit: 4,
            lineWrapping: true,
            autofocus: true,
            extraKeys: {
                "Ctrl-Space": function(cm) {
                    // 根据当前模式选择补全方式
                    var mode = cm.getMode().name;
                    if (mode === 'htmlmixed' || mode === 'xml') {
                        CodeMirror.showHint(cm, CodeMirror.hint.html);
                    } else if (mode === 'css') {
                        CodeMirror.showHint(cm, CodeMirror.hint.css);
                    } else if (mode === 'javascript') {
                        CodeMirror.showHint(cm, CodeMirror.hint.javascript);
                    } else {
                        CodeMirror.showHint(cm, customHint);
                    }
                },
                "Ctrl-Enter": function(cm) {
                    cm.save();
                    cm.getTextArea().form.submit();
                },
                "Tab": function(cm) {
                    if (cm.somethingSelected()) {
                        cm.indentSelection("add");
                    } else {
                        cm.replaceSelection(cm.getOption("indentWithTabs") ? "\t" : 
                            Array(cm.getOption("indentUnit") + 1).join(" "), "end", "+input");
                    }
                }
            }
        });
        
        // 自动触发补全
        editor.on('keyup', function(cm, event) {
            if (!cm.state.completionActive && 
                (event.keyCode > 46 && event.keyCode < 91 || event.keyCode === 189 || event.keyCode === 222)) {
                
                var mode = cm.getMode().name;
                if (mode === 'htmlmixed' || mode === 'xml') {
                    CodeMirror.showHint(cm, CodeMirror.hint.html);
                } else if (mode === 'css') {
                    CodeMirror.showHint(cm, CodeMirror.hint.css);
                } else if (mode === 'javascript') {
                    CodeMirror.showHint(cm, CodeMirror.hint.javascript);
                } else {
                    CodeMirror.showHint(cm, customHint);
                }
            }
        });
    });
    </script>
HTML;
}

// 根据文件扩展名获取 CodeMirror 模式（保持不变）
function getEditorMode($filename)
{
    $extension = pathinfo($filename, PATHINFO_EXTENSION);
    $modeMap = [
        'php' => 'application/x-httpd-php',
        'js' => 'javascript',
        'html' => 'htmlmixed',
        'css' => 'css',
        'c' => 'clike',
        'cpp' => 'clike',
        'java' => 'clike',
        'sh' => 'shell',
        'xml' => 'xml',
        'json' => 'javascript',
        'py' => 'python',
        'ts' => 'javascript',
        'txt' => 'text/plain',
        'md' => 'markdown',
        'sql'=> 'sql',
        // 添加更多文件类型映射
    ];
    return $modeMap[strtolower($extension)] ?? 'text/plain';
}

if (!isset($_GET['path'])) {
    header("Location: ./404.php");
    exit;
} elseif (($path = trim($_GET['path'])) == "") {
    header("Location: ./404.php");
    exit;
} elseif (!is_file($path)) {
    header("Location: ./404.php");
    exit;
} elseif (!is_writable($path)) {
    xhtml_head("编辑文件");
    echo "<div class=\"like\">\n";
    echo "<a href=\"./index.php?path=" . urlencode(dirname($path)) . "\"]>返回目录</a>错误提示\n";
    echo "</div>\n";
    echo "<div class=\"love\">\n";
    echo "此文件您没有写入权限！";
    echo "</div>\n";
    xhtml_footer();
} else {
    // 获取文件扩展名对应的编辑器模式
    $editorMode = getEditorMode($path);

    xhtml_head("编辑文件");
    // 包含 CodeMirror 资源
    includeCodeMirror($editorMode);

    echo "<div class=\"like\">\n";
    echo "<a href=\"./index.php?path=" . urlencode(dirname($path)) . "\"]>返回目录</a>选择编码\n";
    echo "</div>\n";
    echo "<div class=\"love\">";
    echo "<form action=\"\" method=\"GET\">\n";
    echo "<select name=\"charset\">\n";
    if (!function_exists("mb_convert_encoding")) {
        echo "<option>缺少模块</option>\n";
    } else {
        $sencode = mb_list_encodings();
        usort($sencode, "___sortcmp");
        foreach ($sencode as $encode) {
            if ($encode == "pass") {
                continue;
            }
            if (function_exists("mb_encoding_aliases")) {
                $alias = mb_encoding_aliases($encode);
                echo "\n<optgroup label=\"$encode\">\n";
                echo "<option value=\"$encode\">$encode</option>\n";
                if (is_array($alias)) if (count($alias) >= 1) {
                    usort($alias, "___sortcmp");
                    foreach ($alias as $encodealias) {
                        if ($encodealias == $encode) {
                            continue;
                        }
                        echo "<option value=\"$encode\">$encodealias</option>\n";
                    }
                }
                echo "</optgroup>\n";
            } else {
                echo "<option value=\"$encode\">$encode</option>\n";
            }
        }
    }
    echo "</select>\n";
    echo "<input type=\"hidden\" name=\"path\" value=\"$path\" />";
    echo "<input type=\"submit\" value=\"设置编码\" />\n";
    echo "</form>\n";
    echo "</div>\n";
    if (isset($_POST['content'])) if (trim($_POST['content']) != "") {
        echo "<div class=\"like\">文件保存情况报告</div>\n";
        if (!function_exists("get_magic_quotes_gpc") || !get_magic_quotes_gpc()) {
            $fcontent = $_POST['content'];
        } else {
            $fcontent = stripslashes($_POST['content']);
        }
        if (isset($_POST['charset'])) if (trim($_POST['charset']) != "") {
            $fcontent = ___convert($fcontent, trim($_POST['charset']), "UTF-8");
        }
        echo "<div class=\"love\">\n";
        if (file_put_contents($path, $fcontent)) {
            echo "文件数据已经成功存储！\n";
        } else {
            echo "文件数据无法存入文件！\n";
        }
        echo "</div>\n";
    }
    $data = file_get_contents($path);
    if (!isset($_GET['charset'])) {
        $charset = null;
        $content = ___codepre($data, null);
    } elseif (($charset = trim($_GET['charset'])) == "") {
        $content = ___codepre($data, null);
    } else {
        $content = ___codepre(___convert($data, "UTF-8", $charset), null);
    }
    echo "<div class=\"like\">爱特文本编辑工具</div>\n";
    echo "<div class=\"love\">\n";
    echo "<form action=\"?path=" . urlencode($path) . "&charset={$charset}\" method=\"POST\">\n";
    echo "<input type=\"submit\" value=\"保存文件\" />\n";
    echo "<input type=\"reset\" value=\"重置文件\" />\n<br /><br />\n";
    if (isset($_GET['charset'])) if ($charset != "") {
        echo "<input type=\"hidden\" name=\"charset\" value=\"$charset\" />\n";
    }
    // 修改 textarea 为支持 CodeMirror 的版本
    echo "<textarea id=\"codeEditor\" name=\"content\" style=\"width:99%;height:400px;\">$content</textarea>\n<br/>\n";
    echo "</form>\n";
    echo "</div>\n";
    xhtml_footer();
}
?>